.MODEL TINY

.CODE

INCLUDE 8088.INC

DIR EQU DS:[0]		;RAM PLACE WHERE WE STORE THE DIRECION
MOTOR EQU DS:[1]	;RAM SPACE WHERE WE STORE THE MOTORS PIN STATUS

ORG 0

START:
	;SET START OF DATA SEGMENT TO 1000H
	;SO, DS=100H
	MOV AX,100H
	MOV DS,AX

	MOV AX,0H
	MOV SS,AX
	MOV AX,800H	;SET STACK START ADDRESS AT 800H
	MOV SP,AX

	;INITIALIZE THE PPI
	MOV AL,10000010B
	OUT PPI0_CTRL,AL	;SET PORTA AS OUTPUT AND PORTB AS INPUT

	;SET INITIAL DIRECTION
	MOV DIR,0
	;SET INITAL MOTOR MAGNETIZATION
	MOV MOTOR,1

CHECK_DIR:
	;READ THE STATUS OF THE BUTTONS FROM PORTB
	IN AL,PPI0_B

	;CHECK THE DIRECTION BUTTON
	;MOV DIR,AL
	;AND DIR,01H
	OUT PPI0_C,AL
	TEST AL,01H	;IS DIRECTION=1?
	JNZ LEFT	;IT IS, SO GO LEFT

RIGHT:			;IT ISN'T SO GO RIGHT
	SHL MOTOR,1
	TEST MOTOR,00010000B	;HAVE WE REACHED THE END?
	JNZ RIGHT_END_REACHED	;WE HAVE SO RESET IT
	JMP OUTPUT		;WE HAVEN'T REACHED THE END, SO OUTPUT THE RESULT

RIGHT_END_REACHED:
	MOV MOTOR,01H
	JMP OUTPUT

LEFT:
        SHR MOTOR,1
        JZ LEFT_END_REACHED	;IF WE'VE REACHED THE END, THEN MOTOR WILL EQUAL 0
	JMP OUTPUT

LEFT_END_REACHED:
	MOV MOTOR,00001000B

OUTPUT:
	MOV AL,MOTOR
	OUT PPI0_A,AL	;OUTPUT THE MOTOR STATUS

	CALL DELAY	;DELAY A LITTLE
	JMP CHECK_DIR	;START AGAIN

;##############################
;Delay subroutine

DELAY PROC
	MOV CX,2000H
DELAY_LOOP:
	LOOP DELAY_LOOP
	RET
DELAY ENDP

ORG 7FF0H
	JMP START 
	

	END